MaxentModel (Apache OpenNLP :: API 3.0.0-M4 API)
Description: declaration: package: opennlp.tools.ml.model, interface: MaxentModel

Package opennlp.tools.ml.model

# Interface MaxentModel

public interface MaxentModel
Interface for maximum entropy models.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `double[]`
  `eval(String[] context)`
  Evaluates a `context`.
  `double[]`
  `eval(String[] context, double[] probs)`
  Evaluates a `context`.
  `double[]`
  `eval(String[] context, float[] values)`
  Evaluates a `context` with the specified context `values`.
  `String`
  `getAllOutcomes(double[] outcomes)`
  Retrieves a string matching all the outcome names with all the probabilities produced by the `eval(String[])` method.
  `String`
  `getBestOutcome(double[] outcomes)`
  Retrieves the outcome associated with the index containing the highest probability in the double[].
  `int`
  `getIndex(String outcome)`
  Retrieves the index associated with the String name of the given outcome.
  `int`
  `getNumOutcomes()`
  `String`
  `getOutcome(int i)`
  Retrieves the String name of the outcome associated with the index `i`.

- ## Method Details

  - ### eval

    double[] eval(String[] context)
    Evaluates a `context`.
    Parameters:
      `context` - An array of String names of the contextual predicates which are to be evaluated together.
    Returns:
      An array of the probabilities for each of the different outcomes, all of which sum to `1`.

  - ### eval

    double[] eval(String[] context, double[] probs)
    Evaluates a `context`.
    Parameters:
      `context` - An array of String names of the contextual predicates which are to be evaluated together.
      `probs` - An array which is populated with the probabilities for each of the different outcomes, all of which sum to 1.
    Returns:
      An array of the probabilities for each of the different outcomes, all of which sum to `1`.

  - ### eval

    double[] eval(String[] context, float[] values)
    Evaluates a `context` with the specified context `values`.
    Parameters:
      `context` - An array of String names of the contextual predicates which are to be evaluated together.
      `values` - The values associated with each context.
    Returns:
      An array of the probabilities for each of the different outcomes, all of which sum to `1`.

  - ### getBestOutcome

    String getBestOutcome(double[] outcomes)
    Retrieves the outcome associated with the index containing the highest probability in the double[].
    Parameters:
      `outcomes` - A `double[]` as returned by the `eval(String[])` method.
    Returns:
      The String name of the best outcome.

  - ### getAllOutcomes

    String getAllOutcomes(double[] outcomes)
    Retrieves a string matching all the outcome names with all the probabilities produced by the `eval(String[])` method.
    Parameters:
      `outcomes` - A `double[]` as returned by the `eval(String[])` method.
    Returns:
      String containing outcome names paired with the normalized probability (contained in the `double[] ocs`) for each one.

  - ### getOutcome

    String getOutcome(int i)
    Retrieves the String name of the outcome associated with the index `i`.
    Parameters:
      `i` - The index for which the name of the associated outcome is desired.
    Returns:
      The String name of the outcome

  - ### getIndex

    int getIndex(String outcome)
    Retrieves the index associated with the String name of the given outcome.
    Parameters:
      `outcome` - The String name of the outcome for which the index is desired,
    Returns:
      The index if the given outcome label exists for this model, `-1` if it does not.

  - ### getNumOutcomes

    int getNumOutcomes()
    Returns:
      Retrieves the number of outcomes for this model.